//+++++++++++++++++++++++++++++Ambilight PWM++++++++++++++++++++++++++++++

//Calculates the color sequence based on the time

void ambilight_pwm_calc(void)
{
static uint8_t prescaler_red, prescaler_green;

//blue (once a minute)
if (pwm_sequence.blue == FALSE)
	{
	pwm_blue++;
	if (pwm_blue == PWM_MAX)
		pwm_sequence.blue = TRUE;
		}
	//dim down
else 
	{
	pwm_blue--;
	if (pwm_blue == PWM_MIN)
		pwm_sequence.blue = FALSE;
	}

//green (once a hour)
prescaler_green++;
if (prescaler_green == 60)
	{
	prescaler_green = 0;
	//dim up
	if (pwm_sequence.green == FALSE)
		{
		pwm_green++;
		if (pwm_green == PWM_MAX)
			pwm_sequence.green = TRUE;
		}
	//dim down
	else 
		{
		pwm_green--;
		if (pwm_green == PWM_MIN)
			pwm_sequence.green = FALSE;
		}

	//red (once a day)
	prescaler_red++;
	if (prescaler_red == 24)
		{
		prescaler_red = 0;
		//dim up
		if (pwm_sequence.red == FALSE)
			{
			pwm_red++;
			if (pwm_red == PWM_MAX)
				pwm_sequence.red = TRUE;
			}
		//dim down
		else 
			{
			pwm_red--;
			if (pwm_red == PWM_MIN)
				pwm_sequence.red = FALSE;
			}
		}
	}
}

//this is the pwm for the ambilight

void ambilight_pwm(void)
{
//This does the soft-PWM if ambilight is set to "farbzeit" in menu.

//Variables - use static to force the compiler to use static memory place. Otherwise this will not work!
static uint8_t pwmdiv;

pwmdiv++;
if (pwmdiv == PWM_DIVIDER)
	pwmdiv = 0;
else
	{
	//blue
	if (pwmdiv > pwm_blue)
		PORTC &= ~_BV(LED2);
	else 
		PORTC |= _BV(LED2);
	//green
	if (pwmdiv > pwm_green)
		PORTC &= ~_BV(LED3);
	else 
		PORTC |= _BV(LED3);
	//red 
	if (pwmdiv > pwm_red)
		PORTC &= ~_BV(LED4);
	else 
		PORTC |= _BV(LED4);
	}
}

//This recreates the pwm_sequence start colors

void recreate_pwm_sequence(void)
{
if (time.h < 12)
	{
	//calculate: hours * 10 + part of minutes (max. 5) + part of seconds (max 5) + 1 = 1...121
	pwm_red = (time.h * 10  + time.m / 10 + time.s / 10) + 1;
	pwm_sequence.red = FALSE;
}
else
	{
	//calculate: PWM_MAX - ((hours - 12) * 10 + part of minutes (max. 5) + part of seconds (max 5)) = 121...1
	pwm_red = PWM_MAX - ((time.h - 12) * 10  + time.m / 10 + time.s / 10);
	pwm_sequence.red = TRUE;
	}
if (time.m < 30)
	{
	//calculate: (minutes * 4 + part of seconds (max. 4)) = 1...121
	pwm_green = (time.m * 4  + time.s / 15) + 1;
	pwm_sequence.green = FALSE;
	}
else
	{
	//calculate: (PWM_MAX - ((minutes - 30) * 4 + part of seconds (max 4)) = 121...1
	pwm_green = PWM_MAX - ((time.m - 30) * 4  + time.s / 15);
	pwm_sequence.green = TRUE;
	}
if (time.s <= 30)
	{
	//calculate: seconds * 4 + 1 = 1...121
	pwm_blue = time.s * 4 + 1;
	pwm_sequence.blue = FALSE;
	}
else
	{
	//calculate: PWM_MAX - ((seconds - 30) * 4) - correcture value (max 4) = 121...1
	pwm_blue = PWM_MAX - ((time.s - 30) * 4) - ((time.s - 30) / 7) ;
	pwm_sequence.blue = TRUE;
	}
} 
