/**************************** MAIN-MENU *****************************/

void show_menu(void)
{
 switch(displaymode) {
 	case (SHOW_TIME):
		displaymode = SET_ALARM;
		display_str(LANG_ALARM, FALSE);
		set_alarm();
		break;
      	case (SET_ALARM):
		displaymode = SET_TIMER;
		display_str(LANG_TIMER, FALSE);
		set_countdown();
		break;
      	case (SET_TIMER):
		ctrl_struct.timeunknown = 0;
		displaymode = SET_TIME;
		display_str(LANG_TIME, FALSE);
		set_time();
		break;
      	case (SET_TIME):
		ctrl_struct.timeunknown = 0;
		displaymode = SET_DATE;
		display_str(LANG_DATE, FALSE);
		set_date();
		break;
      	case (SET_DATE):
		displaymode = SET_EFFECT;
		display_str(LANG_EFFECT, FALSE);
		set_display_effect();
		break;
      	case (SET_EFFECT):
		displaymode = SET_LIGHT;
		display_str(LANG_LIGHT, FALSE);
		set_ambilight();
		break;
      	case (SET_LIGHT):
		displaymode = SET_BRIGHTNESS;
		display_str(LANG_CONT, FALSE);
		set_brightness();
		break;
      	case (SET_BRIGHTNESS):
		displaymode = SET_VOLUME;
		display_str(LANG_VOL, FALSE);
		set_volume();
		break;
      	case (SET_VOLUME):
		displaymode = SET_TICK;
		display_str(LANG_TICK, FALSE);
		set_ticktack();
		break;
      	case (SET_TICK):
		displaymode = SET_REGION;
		display_str(LANG_REG, FALSE);
		set_region();
		break;

	/*
      case (SET_REGION):
	displaymode = xxx;
	display_str(LANG_xxx);
	xxx();
	break;
	*/
      	default:
		displaymode = SHOW_TIME;
      }
}

/**************************** SUB-MENUS *****************************/

void set_alarm(void) 
{
uint8_t mode;
uint8_t hour, min, sec;
    
hour = min = sec = 0;
mode = SHOW_MENU;

hour = alarm_h;
min = alarm_m;
sec = 0;
  
timeoutcounter = INACTIVITYTIMEOUT;
  
while (1) {
    if (just_pressed & 0x1) { // mode change
      return;
    }
    if (just_pressed || pressed) {
      timeoutcounter = INACTIVITYTIMEOUT;  
      // timeout w/no buttons pressed after 3 seconds?
    } else if (!timeoutcounter) {
      //timed out!
      	displaymode = SHOW_TIME;     
      	alarm_h = hour;
      	alarm_m = min;
      	return;
    	}
    if (just_pressed & 0x2) {
      	just_pressed = 0;
    	if (mode == SHOW_MENU) {
		// ok now its selected
		mode = SET_HOUR;
		display_alarm(hour, min);
		display[1] |= 0x1;
		display[2] |= 0x1;	
   	 } else if (mode == SET_HOUR) {
		mode = SET_MIN;
		display_alarm(hour, min);
		display[4] |= 0x1;
		display[5] |= 0x1;
 	   } else {
	// done!
		alarm_h = hour;
		alarm_m = min;
		eeprom_write_byte((uint8_t *)EE_ALARM_HOUR, hour);    
		eeprom_write_byte((uint8_t *)EE_ALARM_MIN, min);    
		displaymode = SHOW_TIME;
		return;
   	   }
    }
    if ((just_pressed & 0x4) || (pressed & 0x4)) {
      just_pressed = 0;

      	if (mode == SET_HOUR) {
		hour = (hour+1) % 24;
		display_alarm(hour, min);
		display[1] |= 0x1;
		display[2] |= 0x1;
     	 }
     	 if (mode == SET_MIN) {
		min = (min+1) % 60;
		display_alarm(hour, min);
		display[4] |= 0x1;
		display[5] |= 0x1;
  	    }

     	 if (pressed & 0x4)
		delayms(200);
    }
  }
}

void set_countdown(void) {
uint8_t mode = SHOW_MENU;

timeoutcounter = INACTIVITYTIMEOUT;;  

while (1) {
    if (just_pressed || pressed) {
      timeoutcounter = INACTIVITYTIMEOUT;;  
      // timeout w/no buttons pressed after 3 seconds?
    } else if (!timeoutcounter) {
      //timed out!
      displaymode = SHOW_TIME;     
      return;
    }
    if (just_pressed & 0x1) { // mode change
      	return;
    }
    if (just_pressed & 0x2) {

      	just_pressed = 0;
      	if (mode == SHOW_MENU) {
		// start!
		mode = SET_TIM;
		// new countdown;
		countdown = 0;
		ctrl_struct.countdown_is_set = FALSE;
		// countdown timer
		display_str("timer", FALSE);
		display[6] = pgm_read_byte(numbertable_p + (countdown / 100)) | 0x1;
		display[7] = pgm_read_byte(numbertable_p + ((countdown % 100) / 10)) | 0x1;
		display[8] = pgm_read_byte(numbertable_p + (countdown % 10)) | 0x1;
      	} else {
		if (countdown)
			ctrl_struct.countdown_is_set = 1;	
		displaymode = SHOW_TIME;
		return;
      	}
    }
    if ((just_pressed & 0x4) || (pressed & 0x4)) {
      	just_pressed = 0;
      	if (mode == SET_TIM) {
		countdown += 1;
		if (countdown > 240)
	  		countdown = 0;
		display[6] = pgm_read_byte(numbertable_p + (countdown / 100)) | 0x1;
		display[7] = pgm_read_byte(numbertable_p + ((countdown % 100) / 10)) | 0x1;
		display[8] = pgm_read_byte(numbertable_p + (countdown % 10)) | 0x1;	
      	}
    if (pressed & 0x4)
	delayms(200);
    }
  }
}

void set_time(void) 
{
uint8_t mode;
uint8_t hour, min, sec;
    
hour = time.h;
min = time.m;
sec = time.s;
mode = SHOW_MENU;

timeoutcounter = INACTIVITYTIMEOUT;
  
while (1) {
    if (just_pressed & 0x1) { // mode change
      return;
    }
    if (just_pressed || pressed) {
      timeoutcounter = INACTIVITYTIMEOUT;  
      // timeout w/no buttons pressed after 3 seconds?
    } else if (!timeoutcounter) {
      //timed out!
      displaymode = SHOW_TIME;     
      return;
    }
    if (just_pressed & 0x2) {
	just_pressed = 0;
      	if (mode == SHOW_MENU) {
		hour = time.h;
		min = time.m;
		sec = time.s;

		// ok now its selected
		mode = SET_HOUR;
		display_time(hour, min, sec, FALSE);
		display[1] |= 0x1;
		display[2] |= 0x1;	
	      } 
	else if (mode == SET_HOUR) {
		mode = SET_MIN;
		display_time(hour, min, sec, FALSE);
		display[4] |= 0x1;
		display[5] |= 0x1;
      } else if (mode == SET_MIN) {
		mode = SET_SEC;
		display_time(hour, min, sec, FALSE);
		display[7] |= 0x1;
		display[8] |= 0x1;
      } else {
	// done!
		time.h = hour;
		time.m = min;
		time.s = sec;
		if (effect_ctrl.effect == TRUE) 
			recreate_pwm_sequence();
		displaymode = SHOW_TIME;
		return;
      	}
    }
    if ((just_pressed & 0x4) || (pressed & 0x4)) {
      just_pressed = 0;
      
      	if (mode == SET_HOUR) {
		hour = (hour+1) % 24;
		display_time(hour, min, sec, FALSE);
		display[1] |= 0x1;
		display[2] |= 0x1;
		time.h = hour;
		eeprom_write_byte((uint8_t *)EE_HOUR, time.h);    
		if (effect_ctrl.effect == TRUE) 
			recreate_pwm_sequence();
	      }
	if (mode == SET_MIN) {
		min = (min+1) % 60;
		display_time(hour, min, sec, FALSE);
		display[4] |= 0x1;
		display[5] |= 0x1;
		time.m = min;
		eeprom_write_byte((uint8_t *)EE_MIN, time.m);
		if (effect_ctrl.effect == TRUE) 
			recreate_pwm_sequence();
 	     }
	      if ((mode == SET_SEC) ) {
		sec = (sec+1) % 60;
		display_time(hour, min, sec, FALSE);
		display[7] |= 0x1;
		display[8] |= 0x1;
		time.s = sec;
		eeprom_write_byte((uint8_t *)EE_SEC, time.s);
		if (effect_ctrl.effect == TRUE) 
			recreate_pwm_sequence();
	      }
      
      	if (pressed & 0x4)
		delayms(200);
    	}
  }
}



void set_date(void) {
uint8_t mode = SHOW_MENU;
uint8_t day, month, year;
    
day = time.d;
month = time.mo;
year = time.y;

timeoutcounter = INACTIVITYTIMEOUT;;  

while (1) {
    if (just_pressed || pressed) {
      timeoutcounter = INACTIVITYTIMEOUT;;  
      // timeout w/no buttons pressed after 3 seconds?
    } else if (!timeoutcounter) {
      //timed out!
      displaymode = SHOW_TIME;     
      return;
    }
    if (just_pressed & 0x1) { // mode change
      return;
    }
    if (just_pressed & 0x2) {

	just_pressed = 0;
      	if (mode == SHOW_MENU) {
		// start!
		if (time.r == REGION_US) {
	  		mode = SET_MONTH;
		}
		else {
	  		mode = SET_DAY;
		}
		display_date(day, month, year, DATE, FALSE);
		display[1] |= 0x1;
		display[2] |= 0x1;
  	} else if (((mode == SET_MONTH) && (time.r == REGION_US)) ||
		((mode == SET_DAY) && (time.r == REGION_EU))) {
		if (time.r == REGION_US)
			mode = SET_DAY;
		else
	  		mode = SET_MONTH;
		display_date(day, month, year, DATE, FALSE);
		display[4] |= 0x1;
		display[5] |= 0x1;
      } else if (((mode == SET_DAY) && (time.r == REGION_US)) ||
	((mode == SET_MONTH) && (time.r == REGION_EU))) {
		mode = SET_YEAR;
		display_date(day, month, year, DATE, FALSE);
		display[7] |= 0x1;
		display[8] |= 0x1;
      } else {
		displaymode = NONE;
		display_date(day, month, year, DATE, FALSE);
		delayms(1500);
		displaymode = SHOW_TIME;
		return;
      	}
    }
    if ((just_pressed & 0x4) || (pressed & 0x4)) {
	just_pressed = 0;
      	if (mode == SET_MONTH) {
		month++;
		if (month >= 13)
			month = 1;
		display_date(day, month, year, DATE, FALSE);
		if (time.r == REGION_US) {
			display[1] |= 0x1;
	  		display[2] |= 0x1;
		} else {
	  		display[4] |= 0x1;
	 		display[5] |= 0x1;
		}
		time.mo = month;
		eeprom_write_byte((uint8_t *)EE_MONTH, time.mo);    
    	  }
      	if (mode == SET_DAY) {
		day++;
  		if (day > 31)
		day = 1;

		display_date(day, month, year, DATE, FALSE);

		if (time.r == REGION_EU) {
	  		display[1] |= 0x1;
	  		display[2] |= 0x1;
		} else {
	  		display[4] |= 0x1;
	  		display[5] |= 0x1;
		}
		time.d = day;
		time.mo = month;
		eeprom_write_byte((uint8_t *)EE_DAY, time.d);    
      	}
      	if (mode == SET_YEAR) {
		year++;
		year %= 100;
		display_date(day, month, year, DATE, FALSE);
		display[7] |= 0x1;
		display[8] |= 0x1;
		time.d = day;
		time.mo = month;
		time.y = year;
		eeprom_write_byte((uint8_t *)EE_YEAR, time.y);    
      	}

      if (pressed & 0x4)
	delayms(200);
    }
  }
}

void set_display_effect(void) {
uint8_t mode = SHOW_MENU;

timeoutcounter = INACTIVITYTIMEOUT;;  
effect_ctrl.effect = eeprom_read_byte((uint8_t *)EE_EFFECT);

while (1) {
    if (just_pressed || pressed) {
      	timeoutcounter = INACTIVITYTIMEOUT;;  
      // timeout w/no buttons pressed after 3 seconds?
    } else if (!timeoutcounter) {
      	//timed out!
      	displaymode = SHOW_TIME;     
     	return;
	}
    if (just_pressed & 0x1) { // mode change
      return;
    }
    if (just_pressed & 0x2) {
	just_pressed = 0;
      	if (mode == SHOW_MENU) {
		// start!
		mode = SET_EFF;
		// display time.r
		if (effect_ctrl.effect == TRUE) {
	  		display_str(LANG_ON, FALSE);
		} else {
	  		display_str(LANG_OFF, FALSE);
		}
      } else {	
		displaymode = SHOW_TIME;
		return;
      	}
    }
    if (just_pressed & 0x4) {
      	just_pressed = 0;
      	if (mode == SET_EFF) {
		effect_ctrl.effect = !effect_ctrl.effect;
		if (effect_ctrl.effect == TRUE) {
	  		display_str(LANG_ON, FALSE);
		} else {
	  		display_str(LANG_OFF, FALSE);
		}
		eeprom_write_byte((uint8_t *)EE_EFFECT, effect_ctrl.effect);
      	}
    }
  }
} 

void set_ambilight(void) {
uint8_t mode = SHOW_MENU;

timeoutcounter = INACTIVITYTIMEOUT;;  
effect_ctrl.light = eeprom_read_byte((uint8_t *)EE_LIGHT);

while (1) {
    if (just_pressed || pressed) {
      	timeoutcounter = INACTIVITYTIMEOUT;;  
      // timeout w/no buttons pressed after 3 seconds?
    } else if (!timeoutcounter) {
      	//timed out!
      	displaymode = SHOW_TIME;     
     	return;
	}
    if (just_pressed & 0x1) { // mode change
      return;
    }
    if (just_pressed & 0x2) {
	just_pressed = 0;
      	if (mode == SHOW_MENU) {
		// start!
		mode = SET_LIG;
		// display time.r
		if (effect_ctrl.light == TRUE) {
	  		display_str(LANG_LIGHT_BLUE, FALSE);
		} else {
	  		display_str(LANG_LIGHT_RGB, FALSE);
		}
      } else {	
		displaymode = SHOW_TIME;
		return;
      	}
    }
    if (just_pressed & 0x4) {
      	just_pressed = 0;
      	if (mode == SET_LIG) {
		effect_ctrl.light = !effect_ctrl.light;
		if (effect_ctrl.light == TRUE) {
	  		display_str(LANG_LIGHT_BLUE, FALSE);
			PORTC |= _BV(LED2); 
			PORTC &= ~_BV(LED3);
			PORTC &= ~_BV(LED4);  
		} else {
	  		display_str(LANG_LIGHT_RGB, FALSE);
			recreate_pwm_sequence();
		}
		eeprom_write_byte((uint8_t *)EE_LIGHT, effect_ctrl.light);
      	}
    }
  }
} 

void set_brightness(void) {
uint8_t mode = SHOW_MENU;
uint8_t brightness;

timeoutcounter = INACTIVITYTIMEOUT;;  
brightness = eeprom_read_byte((uint8_t *)EE_BRIGHT);

while (1) {
    if (just_pressed || pressed) {
      timeoutcounter = INACTIVITYTIMEOUT;;  
      // timeout w/no buttons pressed after 3 seconds?
    } else if (!timeoutcounter) {
      //timed out!
      displaymode = SHOW_TIME;     
      eeprom_write_byte((uint8_t *)EE_BRIGHT, brightness);
      return;
    }
    if (just_pressed & 0x1) { // mode change
      	return;
    }
    if (just_pressed & 0x2) {

      	just_pressed = 0;
      	if (mode == SHOW_MENU) {
		// start!
		mode = SET_BRITE;
		// display brightness
		display_str(LANG_BRIGHT, FALSE);
		display[6] = pgm_read_byte(numbertable_p + (brightness / 100)) | 0x1;
		display[7] = pgm_read_byte(numbertable_p + ((brightness % 100) / 10)) | 0x1;
		display[8] = pgm_read_byte(numbertable_p + (brightness % 10)) | 0x1;
      	} else {	
		displaymode = SHOW_TIME;
		return;
      	}
    }
    if ((just_pressed & 0x4) || (pressed & 0x4)) {
      	just_pressed = 0;
      	if (mode == SET_BRITE) {
		brightness += 10;
		if (brightness > 101)
	  		brightness = 10;
		display[6] = pgm_read_byte(numbertable_p + (brightness / 100)) | 0x1;
		display[7] = pgm_read_byte(numbertable_p + ((brightness % 100) / 10)) | 0x1;
		display[8] = pgm_read_byte(numbertable_p + (brightness % 10)) | 0x1;
		eeprom_write_byte((uint8_t *)EE_BRIGHT, brightness);
		if (brightness <= 10) {
	  		OCR0A = 30; 
			} else if (brightness <= 20) {
	  		OCR0A = 35;
			} else if (brightness <= 30) {
			  OCR0A = 40;
			} else if (brightness <= 40) {
			  OCR0A = 45;
			} else if (brightness <= 50) {
			  OCR0A = 50;
			} else if (brightness <= 60) {
			  OCR0A = 60;
			} else if (brightness <= 70) {
			  OCR0A = 70;
			} else if (brightness <= 80) {
			  OCR0A = 80;
			} else if (brightness <= 90) {
			  OCR0A = 85;
			} else if (brightness <= 100) {
			  OCR0A = 90;
			} else {
			  OCR0A = 30;
			}	
      	}

    if (pressed & 0x4)
	delayms(200);
    }
  }
}

void set_volume(void) {
uint8_t mode = SHOW_MENU;

timeoutcounter = INACTIVITYTIMEOUT;;  
ctrl_struct.volume = eeprom_read_byte((uint8_t *)EE_VOLUME);

while (1) {
    if (just_pressed || pressed) {
      timeoutcounter = INACTIVITYTIMEOUT;;  
      // timeout w/no buttons pressed after 3 seconds?
    } else if (!timeoutcounter) {
      //timed out!
      displaymode = SHOW_TIME;     
      return;
    }
    if (just_pressed & 0x1) { // mode change
      return;
    }
    if (just_pressed & 0x2) {
  	   just_pressed = 0;
   	   if (mode == SHOW_MENU) {
		// start!
		mode = SET_VOL;
		// display volume
		if (ctrl_struct.volume) {
	  		display_str(LANG_HIGH, FALSE);
	  		display[5] |= 0x1;
	  		display[6] |= 0x1;
	  		display[7] |= 0x1;
	  		display[8] |= 0x1;
		} else {
	  		display_str(LANG_LOW, FALSE);
	  		display[8] |= 0x1;
		}
      	} else {	
		displaymode = SHOW_TIME;
		return;
      	}
    }
    if (just_pressed & 0x4) {
      	just_pressed = 0;
      	if (mode == SET_VOL) {
		ctrl_struct.volume = !ctrl_struct.volume;
		if (ctrl_struct.volume) {
	  		display_str(LANG_HIGH, FALSE);
	  		display[5] |= 0x1;
			display[6] |= 0x1;
			  display[7] |= 0x1;
			  display[8] |= 0x1;
		} else {
	  		display_str(LANG_LOW, FALSE);
	 		 display[8] |= 0x1;
		}
		eeprom_write_byte((uint8_t *)EE_VOLUME, ctrl_struct.volume);
		speaker_init();
		beep(4000, 1);
      	}
    }
  }
}

void set_ticktack(void) {
uint8_t mode = SHOW_MENU;

timeoutcounter = INACTIVITYTIMEOUT;;  
effect_ctrl.ticktack = eeprom_read_byte((uint8_t *)EE_TICKTACK);

while (1) {
    if (just_pressed || pressed) {
      	timeoutcounter = INACTIVITYTIMEOUT;;  
      // timeout w/no buttons pressed after 3 seconds?
    } else if (!timeoutcounter) {
      	//timed out!
      	displaymode = SHOW_TIME;     
     	return;
	}
    if (just_pressed & 0x1) { // mode change
      return;
    }
    if (just_pressed & 0x2) {
	just_pressed = 0;
      	if (mode == SHOW_MENU) {
		// start!
		mode = SET_TIC;
		// display time.r
		if (effect_ctrl.ticktack  == TRUE) {
	  		display_str(LANG_ON, FALSE);
		} else {
	  		display_str(LANG_TICKTIMER, FALSE);
		}
      } else {	
		displaymode = SHOW_TIME;
		return;
      	}
    }
    if (just_pressed & 0x4) {
      	just_pressed = 0;
      	if (mode == SET_TIC) {
		effect_ctrl.ticktack  = !effect_ctrl.ticktack ;
		if (effect_ctrl.ticktack  == TRUE) {
	  		display_str(LANG_ON, FALSE);
		} else {
	  		display_str(LANG_TICKTIMER, FALSE);
		}
		eeprom_write_byte((uint8_t *)EE_TICKTACK, effect_ctrl.ticktack );
      	}
    }
  }
} 

void set_region(void) {
uint8_t mode = SHOW_MENU;

timeoutcounter = INACTIVITYTIMEOUT;;  
time.r = eeprom_read_byte((uint8_t *)EE_REGION);

while (1) {
    if (just_pressed || pressed) {
      	timeoutcounter = INACTIVITYTIMEOUT;;  
      // timeout w/no buttons pressed after 3 seconds?
    } else if (!timeoutcounter) {
      	//timed out!
      	displaymode = SHOW_TIME;     
     	return;
	}
    if (just_pressed & 0x1) { // mode change
      return;
    }
    if (just_pressed & 0x2) {
	just_pressed = 0;
      	if (mode == SHOW_MENU) {
		// start!
		mode = SET_REG;
		// display time.r
		if (time.r == REGION_US) {
	  		display_str(LANG_US, FALSE);
		} else {
	  		display_str(LANG_EU, FALSE);
		}
      } else {	
		displaymode = SHOW_TIME;
		return;
      	}
    }
    if (just_pressed & 0x4) {
      	just_pressed = 0;
      	if (mode == SET_REG) {
		time.r = !time.r;
		if (time.r == REGION_US) {
	  		display_str(LANG_US, FALSE);
		} else {
	  		display_str(LANG_EU, FALSE);
		}
		eeprom_write_byte((uint8_t *)EE_REGION, time.r);
      	}
    }
  }
} 



